package com.example.demo.service;

import com.example.demo.model.Role;
import com.example.demo.model.User;
import com.example.demo.repository.RoleRepository;
import com.example.demo.repository.UserRepository;

import java.util.Arrays;
import java.util.HashSet;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.stereotype.Service;

@Service
public class UserService implements IUserService {

    @Autowired
    private UserRepository userRepository;
    
    @Autowired
    private RoleRepository roleRepository;
    
    @Autowired
    private BCryptPasswordEncoder bCryptPasswordEncoder;

    @Override
    public void save(User user, String role) {
        if (user.getRoles() == null) {
            Role userRole = roleRepository.findByName(role.toUpperCase());
            user.setRoles(new HashSet<Role>(Arrays.asList(userRole)));
            user.setPassword(bCryptPasswordEncoder.encode(user.getPassword()));
        }
        else{
            Role userRole = roleRepository.findByName(role.toUpperCase());
            user.getRoles().add(userRole);
        }
        userRepository.save(user);
    }

    @Override
    public User findByEmail(String email) {
        return userRepository.findByEmail(email);
    }
}
